unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, MPlayer;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    panWinner: TPanel;
    Nr1: TPanel;
    Nr2: TPanel;
    Nr3: TPanel;
    Nr4: TPanel;
    Nr5: TPanel;
    Nr6: TPanel;
    Nr7: TPanel;
    Nr8: TPanel;
    Nr9: TPanel;
    btnEnde: TButton;
    btnNeu: TButton;
    Bottom: TPanel;
    btnComputer: TButton;
    MP1: TMediaPlayer;
    box1: TCheckBox;
    box2: TCheckBox;
    TonBox: TCheckBox;
    procedure btnEndeClick(Sender: TObject);
    procedure Nr1Click(Sender: TObject);
    procedure Nr2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Nr3Click(Sender: TObject);
    procedure Nr4Click(Sender: TObject);
    procedure Nr5Click(Sender: TObject);
    procedure Nr6Click(Sender: TObject);
    procedure Nr7Click(Sender: TObject);
    procedure Nr8Click(Sender: TObject);
    procedure Nr9Click(Sender: TObject);
    procedure btnNeuClick(Sender: TObject);
    procedure btnComputerClick(Sender: TObject);
    procedure box1Click(Sender: TObject);
    procedure box2Click(Sender: TObject);

  private
    FNormal : integer;
    FPlayer : integer;  { 1 = Player1 / -1 = Player2; }
    FPlayer1: integer;
    FPlayer2: integer;

    FZuege  : ARRAY[1..3, 1..3] OF integer;
    FFelder : ARRAY[1..3, 1..3] OF TPanel;
    FX      : ARRAY[1..3, 1..3] OF integer;

    procedure SetZuege(Sp, Zl: integer; const Value: integer);
    function  GetZuege(Sp, Zl: integer): integer;
    function  ChkZweiDreier(aPlayer: integer): integer;

    procedure Play(aName: string);

  public
    procedure ToggleFeld(Sp, Zl: integer);

    function Gewonnen: boolean;
    function Unentschieden: boolean;

    procedure ComputerZug;

    property Zug[Sp, Zl: integer]: integer read  GetZuege
                                           write SetZuege;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnEndeClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  MP1.DeviceType := dtWaveAudio;
  MP1.Open;
  MP1.Play;

  FNormal := clLime;

  FPlayer1:= clRed;
  FPlayer2:= clBlue;
  FPlayer := 1;

  FFelder[1,1] := Nr1;
  FFelder[2,1] := Nr2;
  FFelder[3,1] := Nr3;
  FFelder[1,2] := Nr4;
  FFelder[2,2] := Nr5;
  FFelder[3,2] := Nr6;
  FFelder[1,3] := Nr7;
  FFelder[2,3] := Nr8;
  FFelder[3,3] := Nr9;

  btnNeuClick(Self);
end;

procedure TForm1.ToggleFeld(Sp, Zl: integer);
begin
  IF (Zug[Sp, Zl] = 0) AND (NOT Gewonnen) AND (NOT Unentschieden) THEN
  BEGIN
    IF FPlayer = 1
    THEN Play('Player1.WAV')
    ELSE Play('Player2.WAV');
    Zug[Sp,Zl] := FPlayer;

    FPlayer:= FPlayer * -1;

    IF FPlayer = 1
    THEN Bottom.Color := FPlayer1
    ELSE Bottom.Color := FPlayer2;

    IF Gewonnen THEN
    BEGIN
      Application.ProcessMessages;
      Sleep(500);
      Play('Gewonnen.WAV');
    END
    ELSE
      IF Unentschieden THEN
      BEGIN
        Application.ProcessMessages;
        Sleep(500);
        Play('Unentschieden.WAV');
      END
      ELSE
        ComputerZug;
  END
  ELSE
    Beep;
end;

procedure TForm1.Nr1Click(Sender: TObject);
begin
  ToggleFeld(1,1);
end;

procedure TForm1.Nr2Click(Sender: TObject);
begin
  ToggleFeld(2,1);
end;


procedure TForm1.Nr3Click(Sender: TObject);
begin
  ToggleFeld(3,1);
end;

procedure TForm1.Nr4Click(Sender: TObject);
begin
  ToggleFeld(1,2);
end;

procedure TForm1.Nr5Click(Sender: TObject);
begin
  ToggleFeld(2,2);
end;

procedure TForm1.Nr6Click(Sender: TObject);
begin
  ToggleFeld(3,2);
end;

procedure TForm1.Nr7Click(Sender: TObject);
begin
  ToggleFeld(1,3);
end;

procedure TForm1.Nr8Click(Sender: TObject);
begin
  ToggleFeld(2,3);
end;

procedure TForm1.Nr9Click(Sender: TObject);
begin
  ToggleFeld(3,3);
end;

procedure TForm1.btnNeuClick(Sender: TObject);
VAR
  sp, zl : integer;

begin
  for Sp := 1 to 3
  do for Zl := 1 to 3
     DO Zug[Sp, Zl] := 0;

  IF FPlayer = 1
  THEN Bottom.Color := FPlayer1
  ELSE Bottom.Color := FPlayer2;

  panWinner.Color := clInfoBk;
  btnComputer.Enabled := NOT (box1.Checked AND box2.Checked);

  IF (box1.Checked AND (FPlayer = +1))
      OR
     (box2.Checked AND (FPlayer = -1))
  THEN ComputerZug;

end;


procedure TForm1.SetZuege(Sp, Zl: integer; const Value: integer);
VAR
  aColor : integer;

begin
  FZuege[Sp,Zl] := Value;

  IF Value > 0
  THEN aColor := FPlayer1
  ELSE
    IF Value < 0
    THEN aColor := FPlayer2
    ELSE aColor := FNormal;

  FFelder[Sp,Zl].Color := aColor;
end;

function TForm1.GetZuege(Sp, Zl: integer): integer;
begin
  Result := FZuege[Sp, Zl];
end;

function TForm1.Gewonnen: boolean;
VAR
  sp, zl,
  Sum   : integer;
  Winner: integer;

begin
  Winner := 0;
  for sp := 1 to 3 do
  begin
    sum := 0;
    for zl := 1 to 3 do
    begin
      sum := sum + Zug[sp,zl];
    end;
    IF ABS(Sum) = 3
    THEN Winner := Sum;
  end;

  for zl := 1 to 3 do
  begin
    sum := 0;
    for sp := 1 to 3 do
    begin
      sum := sum + Zug[sp,zl];
    end;
    IF ABS(Sum) = 3
    THEN Winner := Sum;
  end;

  Sum := Zug[1,1] + Zug[2,2] + Zug[3,3];
  IF ABS(Sum) = 3
  THEN Winner := Sum;

  Sum := Zug[3,1] + Zug[2,2] + Zug[1,3];
  IF ABS(Sum) = 3
  THEN Winner := Sum;

  Result := Winner <> 0;

  IF Result THEN
  BEGIN
    IF Winner > 0
    THEN panWinner.Color := FPlayer1
    ELSE panWinner.Color := FPlayer2;
    Bottom.Color := clWhite;
    IF Winner > 0
    THEN FPlayer := -1
    ELSE FPlayer := +1;
    btnComputer.Enabled := false;
  END;
end;


function TForm1.Unentschieden: boolean;
var
  sp, zl : integer;

begin
  Result := true;

  for sp := 1 to 3
  do for zl := 1 to 3
     do if Zug[sp,zl] = 0
        then result := false;

  IF Result THEN
  BEGIN
    panWinner.Color := clWhite;
    Bottom.Color := clWhite;
    btnComputer.Enabled := false;
  END;
end;

procedure TForm1.btnComputerClick(Sender: TObject);
var
  s2, z2 : integer;
  sp, zl : integer;
  Sum    : integer;
  X0     : integer;

begin
  s2 := 0;
  z2 := 0;
  x0 := 0;

  for sp := 1 to 3
  do for zl := 1 to 3
     do FX[sp,zl] := FZuege[sp,zl] * FPlayer;

  for sp := 1 to 3 do
  begin
    sum := 0;
    for zl := 1 to 3 do
    begin
      Sum := Sum + FX[sp,zl];
      IF FX[Sp, zl] = 0
      THEN x0 := zl;
    END;

    IF ABS(Sum) = 2 THEN
    BEGIN
      s2 := Sp;
      z2 := x0;
      IF Sum > 0 THEN
      BEGIN
        ToggleFeld(s2, z2);  { Gewinnzug }
        Exit;
      END;
    END;
  END;

  for zl := 1 to 3 do
  begin
    sum := 0;
    for sp := 1 to 3 do
    begin
      Sum := Sum + FX[sp,zl];
      IF FX[Sp, zl] = 0
      THEN x0 := sp;
    END;

    IF ABS(Sum) = 2 THEN
    BEGIN
      s2 := x0;
      z2 := zl;
      IF Sum > 0 THEN
      BEGIN
        ToggleFeld(s2, z2);  { Gewinnzug }
        Exit;
      END;
    END;
  END;

  Sum := FX[1,1] + FX[2,2] + FX[3,3];
  IF ABS(Sum) = 2 THEN
  BEGIN
    IF FX[1,1] = 0 THEN
    BEGIN
      s2 := 1;
      z2 := 1;
    END;
    IF FX[2,2] = 0 THEN
    BEGIN
      s2 := 2;
      z2 := 2;
    END;
    IF FX[3,3] = 0 THEN
    BEGIN
      s2 := 3;
      z2 := 3;
    END;
    IF Sum > 0 THEN
    BEGIN
      ToggleFeld(s2, z2);  { Gewinnzug }
      Exit;
    END;
  END;

  Sum := FX[3,1] + FX[2,2] + FX[1,3];
  IF ABS(Sum) = 2 THEN
  BEGIN
    IF FX[3,1] = 0 THEN
    BEGIN
      s2 := 3;
      z2 := 1;
    END;
    IF FX[2,2] = 0 THEN
    BEGIN
      s2 := 2;
      z2 := 2;
    END;
    IF FX[1,3] = 0 THEN
    BEGIN
      s2 := 1;
      z2 := 3;
    END;
    IF Sum > 0 THEN
    BEGIN
      ToggleFeld(s2, z2);  { Gewinnzug }
      Exit;
    END;
  END;

  IF s2 > 0 THEN  { Gewinnzug des Gegners abwehren ? }
  BEGIN
    ToggleFeld(s2, z2);  { Abwehren }
    Exit;
  END;

  for sp := 1 to 3
  do for zl := 1 to 3
     do IF FX[sp, zl] = 0 THEN
        BEGIN
          FX[sp,zl] := +1;
          Sum := ChkZweiDreier(+1);
          IF Sum >= 4 THEN
          BEGIN
            ToggleFeld(sp, Zl);           { Nchste Zug gewinnt dann }
            Exit;
          END;
          FX[sp,zl] := -1;  { Was whre wenn Player2 dorthin setzt ? }
          Sum := ChkZweiDreier(-1);
          IF Sum <= -4 THEN                                    { Ups! }
          BEGIN
            s2 := sp;                    { Das mssen wir uns merken }
            z2 := zl;
          END;
          FX[sp,zl] := 0;                
        END;

  IF s2 > 0 THEN  { Doppelten "Dreier" abwehren ? }
  BEGIN
    ToggleFeld(s2, z2);             { Gegenhalten }
    Exit;
  END;

  REPEAT
    s2 := Random(3) + 1;
    z2 := Random(3) + 1;
    IF FX[s2, z2] = 0 THEN
    BEGIN
      ToggleFeld(s2, z2);  { Freies Feld belegen }
      Exit;
    END;

  UNTIL FALSE;
end;

{ ----- }

function TForm1.ChkZweiDreier(aPlayer: integer): integer;
VAR
  Sum1,
  Sum2 : integer;
  Sp,
  Zl   : integer;

  { --- }

  PROCEDURE ChkSumme(aSum: integer);
  BEGIN
    IF ((aPlayer = +1) AND (aSum >= +2))
         OR
       ((aPlayer = -1) AND (aSum <= -2))
    THEN Result := Result + aSum;
  END; { ChkSumme }

  { --- }

begin
  Result := 0;

  for sp := 1 to 3 do
  begin
    sum1 := 0;
    sum2 := 0;
    for zl := 1 to 3 do
    begin
      Sum1 := Sum1 + FX[sp,zl];
      Sum2 := Sum2 + FX[zl,sp];
    END;
    ChkSumme(Sum1);
    ChkSumme(Sum2);
  END;
  ChkSumme(FX[1,1] + FX[2,2] + FX[3,3]);
  ChkSumme(FX[3,1] + FX[2,2] + FX[1,3]);
END; { ChkZweiDreier }

{ ----- }

procedure TForm1.ComputerZug;
begin
  IF ((FPlayer = +1) AND box1.Checked)
       OR
     ((FPlayer = -1) AND box2.Checked) THEN
  BEGIN
    Screen.Cursor := crHourGlass;
    TRY
      Application.ProcessMessages;
      Sleep(1000);
      btnComputerClick(Self);
    FINALLY
      Screen.Cursor := crDefault;
    END;
  END;
end;

procedure TForm1.box1Click(Sender: TObject);
begin
  btnComputer.Enabled := NOT (box1.Checked AND box2.Checked);
  IF box1.Checked AND (FPlayer = +1)
  THEN ComputerZug;
end;

procedure TForm1.box2Click(Sender: TObject);
begin
  btnComputer.Enabled := NOT (box1.Checked AND box2.Checked);
  IF box2.Checked AND (FPlayer = -1)
  THEN ComputerZug;
end;

procedure TForm1.Play(aName: string);
begin
  IF TonBox.Checked THEN
  BEGIN
    IF MP1.FileName <> aName THEN
    BEGIN
      MP1.FileName := aName;
      MP1.Open;
    END;
    MP1.Play;
  END;
end;

end.
